"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/builtin/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/objectWithoutProperties"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _moment = _interopRequireDefault(require("moment"));

var _DateInput = _interopRequireDefault(require("../DateInput"));

var _TextField = _interopRequireDefault(require("../TextField"));

var _FormControl = _interopRequireDefault(require("../FormControl"));

var _AccessAlarm = _interopRequireDefault(require("../icons/AccessAlarm"));

var _IconButton = _interopRequireDefault(require("../IconButton"));

var _Cancel = _interopRequireDefault(require("../icons/Cancel"));

var _Input = require("../Input");

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _ref2 = _react.default.createElement(_Input.InputAdornment, {
  position: "start"
}, _react.default.createElement(_AccessAlarm.default, null));

var DateTimeInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(DateTimeInput, _Component);

  function DateTimeInput() {
    var _ref;

    var _temp, _this;

    (0, _classCallCheck2.default)(this, DateTimeInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2.default)(_this, (_temp = _this = (0, _possibleConstructorReturn2.default)(this, (_ref = DateTimeInput.__proto__ || Object.getPrototypeOf(DateTimeInput)).call.apply(_ref, [this].concat(args))), _this.onDateChange = function (date) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          value = _this$props.value;

      if (date === '') {
        onChange('');
        return;
      }

      var newDate = new Date(value);
      newDate.setFullYear(date.getFullYear());
      newDate.setMonth(date.getMonth());
      newDate.setDate(date.getDate());
      onChange(newDate);
    }, _this.onTimeChange = function (event) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          value = _this$props2.value;

      var _event$target$value$s = event.target.value.split(':'),
          _event$target$value$s2 = (0, _slicedToArray2.default)(_event$target$value$s, 2),
          hours = _event$target$value$s2[0],
          minutes = _event$target$value$s2[1];

      var newDate = new Date(value === '' ? new Date() : value);
      newDate.setHours(hours);
      newDate.setMinutes(minutes);
      onChange(newDate);
    }, _this.handleCancelClick = function (event) {
      event.stopPropagation();

      _this.props.onChange('');
    }, _temp));
  }

  (0, _createClass2.default)(DateTimeInput, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          dateLabel = _props.dateLabel,
          timeLabel = _props.timeLabel,
          value = _props.value,
          disabled = _props.disabled,
          other = (0, _objectWithoutProperties2.default)(_props, ["classes", "dateLabel", "timeLabel", "value", "disabled"]);
      var initialValue = value ? new Date(value) : undefined;
      return _react.default.createElement(_FormControl.default, {
        className: classes.root
      }, _react.default.createElement(_DateInput.default, (0, _extends2.default)({}, other, {
        onChange: this.onDateChange,
        disabled: disabled,
        value: value,
        label: dateLabel
      })), _react.default.createElement(_TextField.default, (0, _extends2.default)({}, other, {
        value: initialValue ? (0, _moment.default)(initialValue).format('HH:mm') : '',
        onChange: this.onTimeChange,
        label: timeLabel,
        disabled: disabled,
        type: "time",
        InputProps: {
          startAdornment: _ref2,
          endAdornment: _react.default.createElement(_Input.InputAdornment, {
            position: "end"
          }, _react.default.createElement(_IconButton.default, {
            className: (0, _classnames.default)(classes.cancelButtom, (!value || disabled) && classes.cancelButtomHidden),
            disabled: disabled,
            onClick: this.handleCancelClick
          }, _react.default.createElement(_Cancel.default, {
            className: classes.cancelIcon
          })))
        }
      })));
    }
  }]);
  return DateTimeInput;
}(_react.Component);

DateTimeInput.defaultProps = {
  disabled: false
};
DateTimeInput.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.shape({
    root: _propTypes.default.string.isRequired,
    cancelIcon: _propTypes.default.string.isRequired,
    cancelButtom: _propTypes.default.string.isRequired,
    cancelButtomHidden: _propTypes.default.string.isRequired
  }).isRequired,
  dateLabel: _propTypes.default.node.isRequired,
  disabled: _propTypes.default.bool,
  onChange: _propTypes.default.func.isRequired,
  timeLabel: _propTypes.default.node.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.instanceOf(Date), _propTypes.default.string]).isRequired
} : {};

var styles = function styles(theme) {
  var _root;

  return {
    root: (_root = {
      display: 'flex'
    }, (0, _defineProperty2.default)(_root, theme.breakpoints.down('xs'), {
      flexDirection: 'column',
      marginBottom: theme.spacing.small,
      width: '100%'
    }), (0, _defineProperty2.default)(_root, theme.breakpoints.up('sm'), {
      flexDirection: 'row',
      '& > :not(:first-child)': {
        marginLeft: theme.spacing.small
      }
    }), _root),
    cancelButtom: {
      width: 32,
      height: 32,
      transition: theme.transitions.create(['opacity', 'transform'], {
        duration: theme.transitions.duration.shortest,
        easing: theme.transitions.easing.sharp
      })
    },
    cancelButtomHidden: {
      transform: 'scale(.25)',
      opacity: 0
    },
    cancelIcon: {
      width: theme.spacing.small,
      height: theme.spacing.small
    },
    toolbar: {
      backgrounColor: theme.palette.primary.main,
      color: theme.palette.primary.main
    }
  };
};

var _default = (0, _withStyles.default)(styles)(DateTimeInput);

exports.default = _default;