"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/builtin/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _withStyles = _interopRequireDefault(require("../styles/withStyles"));

var _StarBorder = _interopRequireDefault(require("../icons/StarBorder"));

var _StarHalf = _interopRequireDefault(require("../icons/StarHalf"));

var _Star = _interopRequireDefault(require("../icons/Star"));

var styles = function styles(theme) {
  return {
    small: {
      fontSize: theme.spacing.small
    },
    active: {
      color: '#F6A71C'
    },
    disabled: {
      color: theme.palette.grey[100]
    }
  };
};

var RatingStars = function RatingStars(_ref) {
  var classes = _ref.classes,
      rate = _ref.rate,
      disabled = _ref.disabled;
  var rounded = Math.round(rate * 2) / 2;
  var fullStars = Math.floor(rounded);
  var halfStart = Math.ceil(rounded % 1);
  var emptyStars = 5 - halfStart - fullStars;
  var stars = (0, _toConsumableArray2.default)(Array(fullStars).fill(_Star.default)).concat((0, _toConsumableArray2.default)(Array(halfStart).fill(_StarHalf.default)), (0, _toConsumableArray2.default)(Array(emptyStars).fill(_StarBorder.default)));
  return _react.default.createElement("div", {
    className: (0, _classnames.default)(classes.active, disabled && classes.disabled)
  }, // eslint-disable-next-line
  stars.map(function (Star, key) {
    return _react.default.createElement(Star, {
      key: key,
      className: classes.small
    });
  }));
};

RatingStars.propTypes = process.env.NODE_ENV !== "production" ? {
  classes: _propTypes.default.object.isRequired,
  disabled: _propTypes.default.bool,
  rate: _propTypes.default.number
} : {};
RatingStars.defaultProps = {
  disabled: false,
  rate: 0
};

var _default = (0, _withStyles.default)(styles)(RatingStars);

exports.default = _default;